#include "tx_pkt.h"

static txpkt_t *txfree;				/* list of free pkts				*/

struct _net_q	txd_q;				/* qpkt tx q						*/

pid_t tx_done_proxy;
int	tx_failed;


/* called during initialization before regestering with Net	*/
int
tx_init( int n )
{
	int i;
	txpkt_t *t;
	
	tx_done_proxy= qnx_proxy_attach(0,0,0,24);
	if(tx_done_proxy == -1){
		perror("tx_done_proxy");
		exit(-1);
		}
	for(i=0; i<n; i++){
		t= (txpkt_t *)malloc(sizeof(txpkt_t));
		if(!t)
			return -1;
		memset(t, 0, sizeof(txpkt_t));
		t->next= txfree;
		txfree= t;
		}
	return 0;
}
		



/* application functions to get/free tx'd pkts		*/


/* called by application to grab free txpkt_t	*/
/*    before tx'ing a packet					*/
txpkt_t *
get_txpkt()
{
	txpkt_t *t= NULL;

	if(txfree){
		t= txfree;
		txfree= txfree->next;
		}
	return t;
}

/* called by application to re-use tx packet */
/*	after tx'ing a packet					*/
void
put_txpkt( txpkt_t *t )
{
	t->next= txfree;
	txfree= t;
	q_put_first(net_free_q, t->qpkt, 1, net_q_seg);
}
			



/* tx callbacks executed by Net manager						*/



/* passed during registration as .tx_done_fn_ofs field in 
	_net_raw_reg message									*/
/* tx'd packet now in txd_q qpkt list						*/
/* return tx_done_proxy -- Net will trigger this			*/
int far
tx_done()
{
	return tx_done_proxy;
}

